/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Programa para gerenciamento de Greylist com o MTA Sceo via Mysql    
   Programado por Lucas Priori                                         
   Versao: 1.0                                                         
                                                                       
   Compilar:                                                           
   gcc sceo_greylist.c -o sceo_greylist -lmysqlclient                  
                                                                       
  ******************************************************************   
  Copyright (C) 2007  Lucas Priori                                     
                                                                       
  This program is free software: you can redistribute it and/or modify 
  it under the terms of the GNU General Public License as published by 
  the Free Software Foundation, either version 3 of the License, or    
  (at your option) any later version.                                  
                                                                       
  This program is distributed in the hope that it will be useful,      
  but WITHOUT ANY WARRANTY; without even the implied warranty of       
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
  GNU General Public License for more details.                         
                                                                       
  You should have received a copy of the GNU General Public License    
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include<unistd.h>
#include<mysql/mysql.h>
#include<sched.h>
#include<time.h>

#define VERSAO "1.0"
#define ENDERECO "localhost"
#define BD "sceo_greylist"
#define USUARIO "sceo"
#define SENHA "mudar123"
#define DELAY 5
#define DELAY_LIMITE 130
#define DIAS_LIB 35
#define LIMITE 1000


struct servs_tempo{
 char dia_semana[3];
 char fim1;
 char mes[3];
 char fim2;
 char dia[2];
 char fim3;
 char hora[2];
 char fim4;
 char minuto[2];
 char fim5;
 char segundo[2];
 char fim6;
 char ano[4];
 char fim7;
}tlog;
time_t tempo;

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//Funo de log do sistema                          
//Retornos                                          
// 0 = Sucesso                                      
// 1 = Erro ao abrir o arquivo                      
// 2 = Tempo limite de espera atingido              
char sceo_log(char *CAM_log,char *msg_log){
 #define MAX_log_espera 100
 int arq_log;
 unsigned int cont1=0;
 arq_log=open(CAM_log,O_CREAT | O_WRONLY,0666);
 if(arq_log<0)return 1;
 while(lockf(arq_log,F_TLOCK,0)&& cont1<MAX_log_espera){
  cont1++;
  sched_yield();        // Passar a vez para outro processo. Aguardando at o arquivo de log liberar
 }
 if(cont1==MAX_log_espera){
  close(arq_log);
  return 2;
 }
 lseek(arq_log,0,2);
 write(arq_log,msg_log,strlen(msg_log));
 lockf(arq_log,F_ULOCK,0);
 close(arq_log);
 return 0;
}



//---------------------------------------------------
void tempo_log(unsigned int tempo_local){
 memcpy(&tlog,ctime((const time_t *)&tempo_local),sizeof(tlog));
 tlog.fim1=0;
 tlog.fim2=0;
 tlog.fim3=0;
 tlog.fim4=0;
 tlog.fim5=0;
 tlog.fim6=0;
 tlog.fim7=0;
 if(tlog.dia[0]==' ')tlog.dia[0]='0';
 if((tlog.mes[0]=='J')&&(tlog.mes[1]=='a')&&(tlog.mes[2]=='n'))strcpy(tlog.mes,"01");
 else if((tlog.mes[0]=='F')&&(tlog.mes[1]=='e')&&(tlog.mes[2]=='b'))strcpy(tlog.mes,"02");
 else if((tlog.mes[0]=='M')&&(tlog.mes[1]=='a')&&(tlog.mes[2]=='r'))strcpy(tlog.mes,"03");
 else if((tlog.mes[0]=='A')&&(tlog.mes[1]=='p')&&(tlog.mes[2]=='r'))strcpy(tlog.mes,"04");
 else if((tlog.mes[0]=='M')&&(tlog.mes[1]=='a')&&(tlog.mes[2]=='y'))strcpy(tlog.mes,"05");
 else if((tlog.mes[0]=='J')&&(tlog.mes[1]=='u')&&(tlog.mes[2]=='n'))strcpy(tlog.mes,"06");
 else if((tlog.mes[0]=='J')&&(tlog.mes[1]=='u')&&(tlog.mes[2]=='l'))strcpy(tlog.mes,"07");
 else if((tlog.mes[0]=='A')&&(tlog.mes[1]=='u')&&(tlog.mes[2]=='g'))strcpy(tlog.mes,"08");
 else if((tlog.mes[0]=='S')&&(tlog.mes[1]=='e')&&(tlog.mes[2]=='p'))strcpy(tlog.mes,"09");
 else if((tlog.mes[0]=='O')&&(tlog.mes[1]=='c')&&(tlog.mes[2]=='t'))strcpy(tlog.mes,"10");
 else if((tlog.mes[0]=='N')&&(tlog.mes[1]=='o')&&(tlog.mes[2]=='v'))strcpy(tlog.mes,"11");
 else if((tlog.mes[0]=='D')&&(tlog.mes[1]=='e')&&(tlog.mes[2]=='c'))strcpy(tlog.mes,"12");
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
int main(int argc,char *argv[]){
MYSQL *mysql = NULL;
MYSQL_RES *myres; 
MYSQL_ROW myreg;

//=-=-
char existe=0;
char cmd_sql[512];
char usuario[50]=USUARIO;
char senha[50]=SENHA;
char bd[128]=BD;
char clean=0;
char endereco[128]=ENDERECO;
char arg_ip[100]="NULL";
char arg_from[150]="NULL";
char arg_to[150]="NULL";
char arg_l[512]={0};
char ip[100];
char from[150];
char to[150];
unsigned int num_opcoes_basicas=0;
unsigned int temp_bloq=0;
unsigned int temp_lib=0;
unsigned int calc_temp=0;
unsigned int cont1=0;
unsigned int delay=DELAY;
unsigned int delay_limite=DELAY_LIMITE;
unsigned int dias_lib=DIAS_LIB;
unsigned int ult_registro=0;

// =-=-= Lendo parametros =-=-=
for(cont1=1;cont1<argc;cont1++){
 if(!strcmp(argv[cont1-1],"-i")){
  strncpy(arg_ip,argv[cont1],sizeof(arg_ip));
  num_opcoes_basicas++;
 }
 else if(!strcmp(argv[cont1-1],"-f")){
  strncpy(arg_from,argv[cont1],sizeof(arg_from));
  num_opcoes_basicas++;
 }
 else if(!strcmp(argv[cont1-1],"-t")){
  strncpy(arg_to,argv[cont1],sizeof(arg_to));
  num_opcoes_basicas++;
 }
 else if(!strcmp(argv[cont1-1],"-s"))strncpy(endereco,argv[cont1],sizeof(endereco));
 else if(!strcmp(argv[cont1-1],"-d"))strncpy(bd,argv[cont1],sizeof(bd));
 else if(!strcmp(argv[cont1-1],"-u"))strncpy(usuario,argv[cont1],sizeof(usuario));
 else if(!strcmp(argv[cont1-1],"-p"))strncpy(senha,argv[cont1],sizeof(senha));
 else if(!strcmp(argv[cont1-1],"-l"))strncpy(arg_l,argv[cont1],sizeof(senha));
 else if(!strcmp(argv[cont1],"-clean"))clean=1;
 else if(!strcmp(argv[cont1],"--ajuda")){
  printf("SCEO_GREYLIST  versao %s\n\n",VERSAO);
  printf("Sintaxe:\n");
  printf(" ./sceo_greylist <[opcao] [parametro]> ...\n\n");
  printf(" ---- Opcoes basicas ----\n");
  printf(" Opcoes       |  Descricao\n");
  printf("  -i [nome/ip]   -> Campo SERV. Remoto da greylist\n");
  printf("  -f [from]      -> Campo FROM da greylist\n");
  printf("  -t [to]        -> Campo TO da greylist\n");
  printf("\n ---- Opcoes avancadas ----\n");
  printf(" Opcoes       |  Explicacao\n");
  printf("  -s [server]    -> Endereo de conexao do servidor\n");
  printf("  -d [database]  -> Nome do banco de dados\n");
  printf("  -u [user]      -> Usuario do banco de dados\n");
  printf("  -p [password]  -> Senha do banco de dados\n");
  printf("  -clean         -> Deleta registros mortos do banco de dados\n");
  printf("                    mantendo o BD pequeno, limpo e rapido\n");
  printf("                    OBs: agende o CRON para rodar isso uma vez por dia\n");
  printf("  -l [caminho]   -> Cria um arquivo de log de todos os registros excluidos\n");
  printf("                    durante a operao -clean. Com esta opo, podemos saber\n");
  printf("                    quais foram os emails barrados pela Greylist\n");
  printf("\n");
  return 0;
 }else if(!strcmp(argv[cont1],"--help") || !strcmp(argv[cont1],"-h")){
  printf("SCEO_GREYLIST  version %s\n\n",VERSAO);
  printf("Syntax:\n");
  printf(" ./sceo_greylist <[option] [parameter]> ...\n\n");
  printf(" ---- Basic options ----\n");
  printf(" Options       |  Description\n");
  printf("  -i [ip]        -> 'Remote Server' field from greylist\n");
  printf("  -f [from]      -> 'FROM' field from greylist\n");
  printf("  -t [to]        -> 'TO' field from greylist\n");
  printf("\n ---- Advanced options ----\n");
  printf(" Options       |  Description\n");
  printf("  -s [server]    -> Server address\n");
  printf("  -d [database]  -> Database name\n");
  printf("  -u [user]      -> Database user\n");
  printf("  -p [password]  -> Database password\n");
  printf("  -clean         -> Delete dead records, keeping database clean\n");
  printf("  -l [path]      -> Creates a log file of all deleted registers during the operation -clean\n");
  printf("\n");
  return 0;
 }
}

if(clean){
 // -- Eliminando registros mortos do Banco de dados --
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("Nao foi possivel iniciar as funes do Mysql\n\n");
  return 0;
 }
 if(mysql_real_connect(mysql,endereco,usuario,senha,bd,0,NULL,0)){
  time(&tempo);
  calc_temp=tempo-(60 * delay_limite);
  if(arg_l[0]){
   // -- Fazendo log de todos os registros que sero excluidos
   do{
    snprintf(cmd_sql,sizeof(cmd_sql),"SELECT * FROM greylist WHERE temp_bloq>0 AND temp_bloq<%d LIMIT %d,%d",calc_temp,ult_registro,LIMITE);
    cont1=0;
    if(!mysql_query(mysql,cmd_sql)){
     myres=mysql_store_result(mysql);
     while((myreg=mysql_fetch_row(myres))){
      strncpy(ip,myreg[0],sizeof(ip));
      strncpy(from,myreg[1],sizeof(from));
      strncpy(to,myreg[2],sizeof(to));
      temp_bloq=atoi(myreg[3]);
      temp_lib=atoi(myreg[4]);
      tempo_log(temp_bloq);
      snprintf(cmd_sql,sizeof(cmd_sql),"[%s/%s/%s %s:%s:%s] Denied %s  From: %s  To: %s\n",tlog.ano,tlog.mes,tlog.dia,tlog.hora,tlog.minuto,tlog.segundo,ip,from,to);
      sceo_log(arg_l,cmd_sql);
      cont1++;
     }
     ult_registro=ult_registro+cont1;
    }
    mysql_free_result(myres);
   }while(cont1==LIMITE);
  }
  snprintf(cmd_sql,sizeof(cmd_sql),"DELETE FROM greylist WHERE temp_bloq>0 AND temp_bloq<%d",calc_temp);
  mysql_query(mysql,cmd_sql);
  // -- Excluindo registros liberados que ja expiraram --
  calc_temp=tempo-(60 * 60 * 24 * dias_lib);
  snprintf(cmd_sql,sizeof(cmd_sql),"DELETE FROM greylist WHERE temp_lib>0 AND temp_lib<%d",calc_temp);
  mysql_query(mysql,cmd_sql);
 }else printf("Nao foi possivel conectar no banco de dados\n");
 return 0;
}

// -- Processar greylist --
if(num_opcoes_basicas<2){
 printf(" preciso especificar pelo menos 2 opcoes basicas: -i, -f, -t\n\n");
 return 0;
}
mysql = mysql_init(NULL);
if(!mysql){
 printf("Nao foi possivel iniciar as funes do Mysql\n\n");
 return 0;
}
if(mysql_real_connect(mysql,endereco,usuario,senha,bd,0,NULL,0)){
 snprintf(cmd_sql,sizeof(cmd_sql),"SELECT * FROM greylist WHERE campo_srv='%s' AND campo_from='%s' AND campo_to='%s';",arg_ip,arg_from,arg_to);
 existe=0;
 if(!mysql_query(mysql,cmd_sql)){
  myres=mysql_store_result(mysql);
  if((myreg=mysql_fetch_row(myres))!=NULL){
   existe=1;
   strncpy(ip,myreg[0],sizeof(ip));
   strncpy(from,myreg[1],sizeof(from));
   strncpy(to,myreg[2],sizeof(to));
   temp_bloq=atoi(myreg[3]);
   temp_lib=atoi(myreg[4]);
  }
  time(&tempo);
  mysql_free_result(myres);
  if(existe){
   // -- Testando os campos --
   if(temp_lib){
    // -- Possui campo permanente --
    calc_temp=tempo-temp_lib;
    if(calc_temp>(60 * 60 * 24 * dias_lib)){
     // -- Passou do limite de dias, recusando --
     snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE greylist SET temp_bloq=%d, temp_lib=0 WHERE campo_srv='%s' AND campo_from='%s' AND campo_to='%s';",(unsigned int)tempo,arg_ip,arg_from,arg_to);
     mysql_query(mysql,cmd_sql);
     mysql_close(mysql);
     return 1;
    }
    // -- Esta dentro do limite --
    snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE greylist SET temp_bloq=0, temp_lib=%d WHERE campo_srv='%s' AND campo_from='%s' AND campo_to='%s';",(unsigned int)tempo,arg_ip,arg_from,arg_to);
    mysql_query(mysql,cmd_sql);
    mysql_close(mysql);
    return 0;
   }else {
    // -- Nao possui campo permanente --
    calc_temp=tempo-temp_bloq;
    if(calc_temp<(60 * delay)){
     // -- Delay nao expirado, recusar --
     mysql_close(mysql);
     return 1;
    }else {
     if(calc_temp>(60 * delay_limite)){
      // -- Delay limite atingido, recusando --
      snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE greylist SET temp_bloq=%d, temp_lib=0 WHERE campo_srv='%s' AND campo_from='%s' AND campo_to='%s';",(unsigned int)tempo,arg_ip,arg_from,arg_to);
      mysql_query(mysql,cmd_sql);
      mysql_close(mysql);
      return 1;
     }
     // -- Delay expirado, ja pode liberar e alterar o registro --
     snprintf(cmd_sql,sizeof(cmd_sql),"UPDATE greylist SET temp_bloq=0, temp_lib=%d WHERE campo_srv='%s' AND campo_from='%s' AND campo_to='%s';",(unsigned int)tempo,arg_ip,arg_from,arg_to);
     mysql_query(mysql,cmd_sql);
     mysql_close(mysql);
     return 0;
    }
   }
  }else {
   // -- Nao encontrado, Registrando --
   snprintf(cmd_sql,sizeof(cmd_sql),"INSERT INTO greylist VALUES ('%s','%s','%s','%d','0')",arg_ip,arg_from,arg_to,(unsigned int)tempo);
   mysql_query(mysql,cmd_sql);
   mysql_close(mysql);
   return 1;
  }
 }else printf("Erro: [%s]\n\n",cmd_sql);
}else printf("Nao foi possivel conectar no banco de dados\n");

mysql_close(mysql);
return 0;
}
